
# IsWord v1.0 test word existence

class IsWord

    # Word validating class

    RESOURCE_DIR  = File.expand_path( "../resources", File.dirname( __FILE__ ) )

    def initialize()

        # Load dictionary

        @words = {}

        begin

            IO.foreach( RESOURCE_DIR + "/dictionary.txt" ) { |word|
                @words[ word.strip ] = true
            }

        rescue SystemCallError
            # In case of missing resource
            raise IOError.new( "dictoinary.txt resource not found in gem directory" )
        end

    end

    def is?( word )

        # Check for word validity

        begin

            return @words[ word.downcase ]

        rescue NoMethodError
            # For invalid types
            raise TypeError.new( "word must be of type String" )
        end

    end

end


